Index: lemon/Makefile.am
===================================================================
--- lemon/Makefile.am	(revision 259)
+++ lemon/Makefile.am	(revision 338)
@@ -36,4 +36,5 @@
 	lemon/maps.h \
 	lemon/math.h \
+	lemon/max_matching.h \
 	lemon/path.h \
         lemon/random.h \
Index: scripts/unify-sources.sh
===================================================================
--- scripts/unify-sources.sh	(revision 337)
+++ scripts/unify-sources.sh	(revision 208)
@@ -4,164 +4,7 @@
 HGROOT=`hg root`
 
-# file enumaration modes
-
-function all_files() {
-    hg status -a -m -c |
-    cut -d ' ' -f 2 | grep -E '(\.(cc|h|dox)$|Makefile\.am$)' |
-    while read file; do echo $HGROOT/$file; done
-}
-
-function modified_files() {
-    hg status -a -m |
-    cut -d ' ' -f 2 | grep -E  '(\.(cc|h|dox)$|Makefile\.am$)' |
-    while read file; do echo $HGROOT/$file; done
-}
-
-function changed_files() {
-    {
-        if [ -n "$HG_PARENT1" ]
-        then
-            hg status --rev $HG_PARENT1:$HG_NODE -a -m
-        fi
-        if [ -n "$HG_PARENT2" ]
-        then
-            hg status --rev $HG_PARENT2:$HG_NODE -a -m
-        fi
-    } | cut -d ' ' -f 2 | grep -E '(\.(cc|h|dox)$|Makefile\.am$)' | 
-    sort | uniq |
-    while read file; do echo $HGROOT/$file; done
-}
-
-function given_files() {
-    for file in $GIVEN_FILES
-    do
-	echo $file
-    done
-}
-
-# actions
-
-function update_action() {
-    if ! diff -q $1 $2 >/dev/null
-    then
-	echo -n " [$3 updated]"
-	rm $2
-	mv $1 $2
-	CHANGED=YES
-    fi
-}
-
-function update_warning() {
-    echo -n " [$2 warning]"
-    WARNED=YES
-}
-
-function update_init() {
-    echo Update source files...
-    TOTAL_FILES=0
-    CHANGED_FILES=0
-    WARNED_FILES=0
-}
-
-function update_done() {
-    echo $CHANGED_FILES out of $TOTAL_FILES files has been changed.
-    echo $WARNED_FILES out of $TOTAL_FILES files triggered warnings.
-}
-
-function update_begin() {
-    ((TOTAL_FILES++))
-    CHANGED=NO
-    WARNED=NO
-}
-
-function update_end() {
-    if [ $CHANGED == YES ]
-    then
-	((++CHANGED_FILES))
-    fi
-    if [ $WARNED == YES ]
-    then
-	((++WARNED_FILES))
-    fi
-}
-
-function check_action() {
-    if ! diff -q $1 $2 >/dev/null
-    then
-	echo -n " [$3 failed]"
-	FAILED=YES
-    fi
-}
-
-function check_warning() {
-    echo -n " [$2 warning]"
-    WARNED=YES
-}
-
-function check_init() {
-    echo Check source files...
-    FAILED_FILES=0
-    WARNED_FILES=0
-    TOTAL_FILES=0
-}
-
-function check_done() {
-    echo $FAILED_FILES out of $TOTAL_FILES files has been failed.
-    echo $WARNED_FILES out of $TOTAL_FILES files triggered warnings.
-
-    if [ $FAILED_FILES -gt 0 ]
-    then
-	return 1
-    elif [ $WARNED_FILES -gt 0 ]
-    then
-	if [ "$WARNING" == 'INTERACTIVE' ]
-	then
-	    echo -n "Are the files with warnings acceptable? (yes/no) "
-	    while read answer
-	    do
-		if [ "$answer" == 'yes' ]
-		then
-		    return 0
-		elif [ "$answer" == 'no' ]
-		then
-		    return 1
-		fi
-		echo -n "Are the files with warnings acceptable? (yes/no) "
-	    done
-	elif [ "$WARNING" == 'WERROR' ]
-	then
-	    return 1
-	fi
-    fi
-}
-
-function check_begin() {
-    ((TOTAL_FILES++))
-    FAILED=NO
-    WARNED=NO
-}
-
-function check_end() {
-    if [ $FAILED == YES ]
-    then
-	((++FAILED_FILES))
-    fi
-    if [ $WARNED == YES ]
-    then
-	((++WARNED_FILES))
-    fi
-}
-
-
-
-# checks
-
-function header_check() {
-    if echo $1 | grep -q -E 'Makefile\.am$'
-    then
-	return
-    fi
-
+function update_header() {
     TMP_FILE=`mktemp`
+    FILE_NAME=$1
 
     (echo "/* -*- mode: C++; indent-tabs-mode: nil; -*-
@@ -183,5 +26,5 @@
  */
 "
-    awk 'BEGIN { pm=0; }
+	awk 'BEGIN { pm=0; }
      pm==3 { print }
      /\/\* / && pm==0 { pm=1;}
@@ -189,148 +32,103 @@
      /\*\// && pm==1 { pm=2;}
     ' $1
-    ) >$TMP_FILE
+	) >$TMP_FILE
 
-    "$ACTION"_action "$TMP_FILE" "$1" header
+    HEADER_CH=`diff -q $TMP_FILE $FILE_NAME >/dev/null&&echo NO||echo YES`
+
+    rm $FILE_NAME
+    mv $TMP_FILE $FILE_NAME
 }
 
-function tabs_check() {
-    if echo $1 | grep -q -v -E 'Makefile\.am$'
-    then
-        OLD_PATTERN=$(echo -e '\t')
-        NEW_PATTERN='        '
-    else
-        OLD_PATTERN='        '
-        NEW_PATTERN=$(echo -e '\t')
-    fi
+function update_tabs() {
     TMP_FILE=`mktemp`
-    cat $1 | sed -e "s/$OLD_PATTERN/$NEW_PATTERN/g" >$TMP_FILE
+    FILE_NAME=$1
 
-    "$ACTION"_action "$TMP_FILE" "$1" 'tabs'
+    cat $1 |
+    sed -e 's/\t/        /g' >$TMP_FILE
+
+    TABS_CH=`diff -q $TMP_FILE $FILE_NAME >/dev/null&&echo NO||echo YES`
+
+    rm $FILE_NAME
+    mv $TMP_FILE $FILE_NAME
 }
 
-function spaces_check() {
+function remove_trailing_space() {
     TMP_FILE=`mktemp`
-    cat $1 | sed -e 's/ \+$//g' >$TMP_FILE
+    FILE_NAME=$1
 
-    "$ACTION"_action "$TMP_FILE" "$1" 'spaces'
+    cat $1 |
+    sed -e 's/ \+$//g' >$TMP_FILE
+
+    SPACES_CH=`diff -q $TMP_FILE $FILE_NAME >/dev/null&&echo NO||echo YES`
+
+    rm $FILE_NAME
+    mv $TMP_FILE $FILE_NAME
 }
 
-function long_lines_check() {
-    if cat $1 | grep -q -E '.{81,}'
+function long_line_test() {
+    cat $1 |grep -q -E '.{81,}'
+}
+
+function update_file() {
+    echo -n '    update' $i ...
+
+    update_header $1
+    update_tabs $1
+    remove_trailing_space $1
+
+    CHANGED=NO;
+    if [[ $HEADER_CH = YES ]];
     then
-	"$ACTION"_warning $1 'long lines'
+	echo -n '  [header updated]'
+	CHANGED=YES;
+    fi
+    if [[ $TABS_CH = YES ]];
+    then
+	echo -n ' [tabs removed]'
+	CHANGED=YES;
+    fi
+    if [[ $SPACES_CH = YES ]];
+    then
+	echo -n ' [trailing spaces removed]'
+	CHANGED=YES;
+    fi
+    if long_line_test $1 ;
+    then
+	echo -n ' [LONG LINES]'
+	((LONG_LINE_FILES++))
+    fi
+    echo
+    if [[ $CHANGED = YES ]];
+    then
+	((CHANGED_FILES++))
     fi
 }
 
-# process the file
-
-function process_file() {
-    echo -n "    $ACTION " $1...
-
-    CHECKING="header tabs spaces long_lines"
-
-    "$ACTION"_begin $1
-    for check in $CHECKING
+CHANGED_FILES=0
+TOTAL_FILES=0
+LONG_LINE_FILES=0
+if [ $# == 0 ]; then
+    echo Update all source files...
+    for i in `hg manifest|grep -E  '\.(cc|h|dox)$'`
     do
-	"$check"_check $1
+	update_file $HGROOT/$i
+	((TOTAL_FILES++))
     done
-    "$ACTION"_end $1
+    echo '  done.'
+else
+    for i in $*
+    do
+	update_file $i
+	((TOTAL_FILES++))
+    done
+fi
+echo $CHANGED_FILES out of $TOTAL_FILES files has been changed.
+if [[ $LONG_LINE_FILES -gt 1 ]]; then
     echo
-}
-
-function process_all {
-    "$ACTION"_init
-    while read file
-    do
-	process_file $file
-    done < <($FILES)
-    "$ACTION"_done
-}
-
-while [ $# -gt 0 ]
-do
-    
-    if [ "$1" == '--help' ] || [ "$1" == '-h' ]
-    then
-	echo -n \
-"Usage:
-  $0 [OPTIONS] [files]
-Options:
-  --dry-run|-n
-     Check the files, but do not modify them.
-  --interactive|-i
-     If --dry-run is specified and the checker emits warnings,
-     then the user is asked if the warnings should be considered
-     errors.
-  --werror|-w
-     Make all warnings into errors.
-  --all|-a
-     All files in the repository will be checked.
-  --modified|-m
-     Check only the modified (and new) source files. This option is
-     useful to check the modification before making a commit.
-  --changed|-c
-     Check only the changed source files compared to the parent(s) of
-     the current hg node.  This option is useful as hg hook script.
-     To automatically check all your changes before making a commit,
-     add the following section to the appropriate .hg/hgrc file.
-
-       [hooks]
-       pretxncommit.checksources = scripts/unify-sources.sh -c -n -i
-
-  --help|-h
-     Print this help message.
-  files
-     The files to check/unify. If no file names are given, the
-     modified source will be checked/unified
-
-"
-        exit 0
-    elif [ "$1" == '--dry-run' ] || [ "$1" == '-n' ]
-    then
-	[ -n "$ACTION" ] && echo "Invalid option $1" >&2 && exit 1
-	ACTION=check
-    elif [ "$1" == "--all" ] || [ "$1" == '-a' ]
-    then
-	[ -n "$FILES" ] && echo "Invalid option $1" >&2 && exit 1
-	FILES=all_files
-    elif [ "$1" == "--changed" ] || [ "$1" == '-c' ]
-    then
-	[ -n "$FILES" ] && echo "Invalid option $1" >&2 && exit 1
-	FILES=changed_files
-    elif [ "$1" == "--modified" ] || [ "$1" == '-m' ]
-    then
-	[ -n "$FILES" ] && echo "Invalid option $1" >&2 && exit 1
-	FILES=modified_files
-    elif [ "$1" == "--interactive" ] || [ "$1" == "-i" ]
-    then
-	[ -n "$WARNING" ] && echo "Invalid option $1" >&2 && exit 1
-	WARNING='INTERACTIVE'
-    elif [ "$1" == "--werror" ] || [ "$1" == "-w" ]
-    then
-	[ -n "$WARNING" ] && echo "Invalid option $1" >&2 && exit 1
-	WARNING='WERROR'
-    elif [ $(echo $1 | cut -c 1) == '-' ]
-    then
-	echo "Invalid option $1" >&2 && exit 1
-    else
-	[ -n "$FILES" ] && echo "Invalid option $1" >&2 && exit 1
-	GIVEN_FILES=$@
-	FILES=given_files
-	break
-    fi
-    
-    shift
-done
-
-if [ -z $FILES ]
-then
-    FILES=modified_files
+    echo WARNING: $LONG_LINE_FILES files contains long lines!    
+    echo
+elif [[ $LONG_LINE_FILES -gt 0 ]]; then
+    echo
+    echo WARNING: a file contains long lines!
+    echo
 fi
-
-if [ -z $ACTION ]
-then
-    ACTION=update
-fi
-
-process_all
Index: test/CMakeLists.txt
===================================================================
--- test/CMakeLists.txt	(revision 225)
+++ test/CMakeLists.txt	(revision 338)
@@ -17,4 +17,6 @@
   kruskal_test
   maps_test
+  max_matching_test
+  max_weighted_matching_test
   random_test
   path_test
Index: test/Makefile.am
===================================================================
--- test/Makefile.am	(revision 228)
+++ test/Makefile.am	(revision 338)
@@ -20,4 +20,6 @@
 	test/kruskal_test \
         test/maps_test \
+	test/max_matching_test \
+	test/max_weighted_matching_test \
         test/random_test \
         test/path_test \
@@ -43,4 +45,6 @@
 test_kruskal_test_SOURCES = test/kruskal_test.cc
 test_maps_test_SOURCES = test/maps_test.cc
+test_max_matching_test_SOURCES = test/max_matching_test.cc
+test_max_weighted_matching_test_SOURCES = test/max_weighted_matching_test.cc
 test_path_test_SOURCES = test/path_test.cc
 test_random_test_SOURCES = test/random_test.cc
Index: test/max_matching_test.cc
===================================================================
--- test/max_matching_test.cc	(revision 338)
+++ test/max_matching_test.cc	(revision 338)
@@ -0,0 +1,181 @@
+/* -*- mode: C++; indent-tabs-mode: nil; -*-
+ *
+ * This file is a part of LEMON, a generic C++ optimization library.
+ *
+ * Copyright (C) 2003-2008
+ * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
+ *
+ * Permission to use, modify and distribute this software is granted
+ * provided that this copyright notice appears in all copies. For
+ * precise terms see the accompanying LICENSE file.
+ *
+ * This software is provided "AS IS" with no warranty of any kind,
+ * express or implied, and with no claim as to its suitability for any
+ * purpose.
+ *
+ */
+
+#include <iostream>
+#include <vector>
+#include <queue>
+#include <lemon/math.h>
+#include <cstdlib>
+
+#include "test_tools.h"
+#include <lemon/list_graph.h>
+#include <lemon/max_matching.h>
+
+using namespace std;
+using namespace lemon;
+
+int main() {
+
+  typedef ListGraph Graph;
+
+  GRAPH_TYPEDEFS(Graph);
+
+  Graph g;
+  g.clear();
+
+  std::vector<Graph::Node> nodes;
+  for (int i=0; i<13; ++i)
+      nodes.push_back(g.addNode());
+
+  g.addEdge(nodes[0], nodes[0]);
+  g.addEdge(nodes[6], nodes[10]);
+  g.addEdge(nodes[5], nodes[10]);
+  g.addEdge(nodes[4], nodes[10]);
+  g.addEdge(nodes[3], nodes[11]);
+  g.addEdge(nodes[1], nodes[6]);
+  g.addEdge(nodes[4], nodes[7]);
+  g.addEdge(nodes[1], nodes[8]);
+  g.addEdge(nodes[0], nodes[8]);
+  g.addEdge(nodes[3], nodes[12]);
+  g.addEdge(nodes[6], nodes[9]);
+  g.addEdge(nodes[9], nodes[11]);
+  g.addEdge(nodes[2], nodes[10]);
+  g.addEdge(nodes[10], nodes[8]);
+  g.addEdge(nodes[5], nodes[8]);
+  g.addEdge(nodes[6], nodes[3]);
+  g.addEdge(nodes[0], nodes[5]);
+  g.addEdge(nodes[6], nodes[12]);
+
+  MaxMatching<Graph> max_matching(g);
+  max_matching.init();
+  max_matching.startDense();
+
+  int s=0;
+  Graph::NodeMap<Node> mate(g,INVALID);
+  max_matching.mateMap(mate);
+  for(NodeIt v(g); v!=INVALID; ++v) {
+    if ( mate[v]!=INVALID ) ++s;
+  }
+  int size=int(s/2);  //size will be used as the size of a maxmatching
+
+  for(NodeIt v(g); v!=INVALID; ++v) {
+    max_matching.mate(v);
+  }
+
+  check ( size == max_matching.size(), "mate() returns a different size matching than max_matching.size()" );
+
+  Graph::NodeMap<MaxMatching<Graph>::DecompType> pos0(g);
+  max_matching.decomposition(pos0);
+
+  max_matching.init();
+  max_matching.startSparse();
+  s=0;
+  max_matching.mateMap(mate);
+  for(NodeIt v(g); v!=INVALID; ++v) {
+    if ( mate[v]!=INVALID ) ++s;
+  }
+  check ( int(s/2) == size, "The size does not equal!" );
+
+  Graph::NodeMap<MaxMatching<Graph>::DecompType> pos1(g);
+  max_matching.decomposition(pos1);
+
+  max_matching.run();
+  s=0;
+  max_matching.mateMap(mate);
+  for(NodeIt v(g); v!=INVALID; ++v) {
+    if ( mate[v]!=INVALID ) ++s;
+  }
+  check ( int(s/2) == size, "The size does not equal!" );
+
+  Graph::NodeMap<MaxMatching<Graph>::DecompType> pos2(g);
+  max_matching.decomposition(pos2);
+
+  max_matching.run();
+  s=0;
+  max_matching.mateMap(mate);
+  for(NodeIt v(g); v!=INVALID; ++v) {
+    if ( mate[v]!=INVALID ) ++s;
+  }
+  check ( int(s/2) == size, "The size does not equal!" );
+
+  Graph::NodeMap<MaxMatching<Graph>::DecompType> pos(g);
+  max_matching.decomposition(pos);
+
+  bool ismatching=true;
+  for(NodeIt v(g); v!=INVALID; ++v) {
+    if ( mate[v]!=INVALID ) {
+      Node u=mate[v];
+      if (mate[u]!=v) ismatching=false;
+    }
+  }
+  check ( ismatching, "It is not a matching!" );
+
+  bool coincide=true;
+  for(NodeIt v(g); v!=INVALID; ++v) {
+   if ( pos0[v] != pos1[v] || pos1[v]!=pos2[v] || pos2[v]!=pos[v] ) {
+     coincide=false;
+    }
+  }
+  check ( coincide, "The decompositions do not coincide! " );
+
+  bool noarc=true;
+  for(EdgeIt e(g); e!=INVALID; ++e) {
+   if ( (pos[g.v(e)]==max_matching.C &&
+         pos[g.u(e)]==max_matching.D) ||
+         (pos[g.v(e)]==max_matching.D &&
+          pos[g.u(e)]==max_matching.C) )
+      noarc=false;
+  }
+  check ( noarc, "There are arcs between D and C!" );
+
+  bool oddcomp=true;
+  Graph::NodeMap<bool> todo(g,true);
+  int num_comp=0;
+  for(NodeIt v(g); v!=INVALID; ++v) {
+   if ( pos[v]==max_matching.D && todo[v] ) {
+      int comp_size=1;
+      ++num_comp;
+      std::queue<Node> Q;
+      Q.push(v);
+      todo.set(v,false);
+      while (!Q.empty()) {
+        Node w=Q.front();
+        Q.pop();
+        for(IncEdgeIt e(g,w); e!=INVALID; ++e) {
+          Node u=g.runningNode(e);
+          if ( pos[u]==max_matching.D && todo[u] ) {
+            ++comp_size;
+            Q.push(u);
+            todo.set(u,false);
+          }
+        }
+      }
+      if ( !(comp_size % 2) ) oddcomp=false;
+    }
+  }
+  check ( oddcomp, "A component of g[D] is not odd." );
+
+  int barrier=0;
+  for(NodeIt v(g); v!=INVALID; ++v) {
+    if ( pos[v]==max_matching.A ) ++barrier;
+  }
+  int expected_size=int( countNodes(g)-num_comp+barrier)/2;
+  check ( size==expected_size, "The size of the matching is wrong." );
+
+  return 0;
+}
Index: test/max_weighted_matching_test.cc
===================================================================
--- test/max_weighted_matching_test.cc	(revision 338)
+++ test/max_weighted_matching_test.cc	(revision 338)
@@ -0,0 +1,250 @@
+/* -*- mode: C++; indent-tabs-mode: nil; -*-
+ *
+ * This file is a part of LEMON, a generic C++ optimization library.
+ *
+ * Copyright (C) 2003-2008
+ * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
+ *
+ * Permission to use, modify and distribute this software is granted
+ * provided that this copyright notice appears in all copies. For
+ * precise terms see the accompanying LICENSE file.
+ *
+ * This software is provided "AS IS" with no warranty of any kind,
+ * express or implied, and with no claim as to its suitability for any
+ * purpose.
+ *
+ */
+
+#include <iostream>
+#include <sstream>
+#include <vector>
+#include <queue>
+#include <lemon/math.h>
+#include <cstdlib>
+
+#include "test_tools.h"
+#include <lemon/smart_graph.h>
+#include <lemon/max_matching.h>
+#include <lemon/lgf_reader.h>
+
+using namespace std;
+using namespace lemon;
+
+GRAPH_TYPEDEFS(SmartGraph);
+
+const int lgfn = 3;
+const std::string lgf[lgfn] = {
+  "@nodes\n"
+  "label\n"
+  "0\n"
+  "1\n"
+  "2\n"
+  "3\n"
+  "4\n"
+  "5\n"
+  "6\n"
+  "7\n"
+  "@edges\n"
+  "label        weight\n"
+  "7    4       0       984\n"
+  "0    7       1       73\n"
+  "7    1       2       204\n"
+  "2    3       3       583\n"
+  "2    7       4       565\n"
+  "2    1       5       582\n"
+  "0    4       6       551\n"
+  "2    5       7       385\n"
+  "1    5       8       561\n"
+  "5    3       9       484\n"
+  "7    5       10      904\n"
+  "3    6       11      47\n"
+  "7    6       12      888\n"
+  "3    0       13      747\n"
+  "6    1       14      310\n",
+
+  "@nodes\n"
+  "label\n"
+  "0\n"
+  "1\n"
+  "2\n"
+  "3\n"
+  "4\n"
+  "5\n"
+  "6\n"
+  "7\n"
+  "@edges\n"
+  "label        weight\n"
+  "2    5       0       710\n"
+  "0    5       1       241\n"
+  "2    4       2       856\n"
+  "2    6       3       762\n"
+  "4    1       4       747\n"
+  "6    1       5       962\n"
+  "4    7       6       723\n"
+  "1    7       7       661\n"
+  "2    3       8       376\n"
+  "1    0       9       416\n"
+  "6    7       10      391\n",
+
+  "@nodes\n"
+  "label\n"
+  "0\n"
+  "1\n"
+  "2\n"
+  "3\n"
+  "4\n"
+  "5\n"
+  "6\n"
+  "7\n"
+  "@edges\n"
+  "label        weight\n"
+  "6    2       0       553\n"
+  "0    7       1       653\n"
+  "6    3       2       22\n"
+  "4    7       3       846\n"
+  "7    2       4       981\n"
+  "7    6       5       250\n"
+  "5    2       6       539\n"
+};
+
+void checkMatching(const SmartGraph& graph,
+                   const SmartGraph::EdgeMap<int>& weight,
+                   const MaxWeightedMatching<SmartGraph>& mwm) {
+  for (SmartGraph::EdgeIt e(graph); e != INVALID; ++e) {
+    if (graph.u(e) == graph.v(e)) continue;
+    int rw =
+      mwm.nodeValue(graph.u(e)) + mwm.nodeValue(graph.v(e));
+
+    for (int i = 0; i < mwm.blossomNum(); ++i) {
+      bool s = false, t = false;
+      for (MaxWeightedMatching<SmartGraph>::BlossomIt n(mwm, i);
+           n != INVALID; ++n) {
+        if (graph.u(e) == n) s = true;
+        if (graph.v(e) == n) t = true;
+      }
+      if (s == true && t == true) {
+        rw += mwm.blossomValue(i);
+      }
+    }
+    rw -= weight[e] * mwm.dualScale;
+
+    check(rw >= 0, "Negative reduced weight");
+    check(rw == 0 || !mwm.matching(e),
+          "Non-zero reduced weight on matching arc");
+  }
+
+  int pv = 0;
+  for (SmartGraph::NodeIt n(graph); n != INVALID; ++n) {
+    if (mwm.matching(n) != INVALID) {
+      check(mwm.nodeValue(n) >= 0, "Invalid node value");
+      pv += weight[mwm.matching(n)];
+      SmartGraph::Node o = graph.target(mwm.matching(n));
+      check(mwm.mate(n) == o, "Invalid matching");
+      check(mwm.matching(n) == graph.oppositeArc(mwm.matching(o)),
+            "Invalid matching");
+    } else {
+      check(mwm.mate(n) == INVALID, "Invalid matching");
+      check(mwm.nodeValue(n) == 0, "Invalid matching");
+    }
+  }
+
+  int dv = 0;
+  for (SmartGraph::NodeIt n(graph); n != INVALID; ++n) {
+    dv += mwm.nodeValue(n);
+  }
+
+  for (int i = 0; i < mwm.blossomNum(); ++i) {
+    check(mwm.blossomValue(i) >= 0, "Invalid blossom value");
+    check(mwm.blossomSize(i) % 2 == 1, "Even blossom size");
+    dv += mwm.blossomValue(i) * ((mwm.blossomSize(i) - 1) / 2);
+  }
+
+  check(pv * mwm.dualScale == dv * 2, "Wrong duality");
+
+  return;
+}
+
+void checkPerfectMatching(const SmartGraph& graph,
+                          const SmartGraph::EdgeMap<int>& weight,
+                          const MaxWeightedPerfectMatching<SmartGraph>& mwpm) {
+  for (SmartGraph::EdgeIt e(graph); e != INVALID; ++e) {
+    if (graph.u(e) == graph.v(e)) continue;
+    int rw =
+      mwpm.nodeValue(graph.u(e)) + mwpm.nodeValue(graph.v(e));
+
+    for (int i = 0; i < mwpm.blossomNum(); ++i) {
+      bool s = false, t = false;
+      for (MaxWeightedPerfectMatching<SmartGraph>::BlossomIt n(mwpm, i);
+           n != INVALID; ++n) {
+        if (graph.u(e) == n) s = true;
+        if (graph.v(e) == n) t = true;
+      }
+      if (s == true && t == true) {
+        rw += mwpm.blossomValue(i);
+      }
+    }
+    rw -= weight[e] * mwpm.dualScale;
+
+    check(rw >= 0, "Negative reduced weight");
+    check(rw == 0 || !mwpm.matching(e),
+          "Non-zero reduced weight on matching arc");
+  }
+
+  int pv = 0;
+  for (SmartGraph::NodeIt n(graph); n != INVALID; ++n) {
+    check(mwpm.matching(n) != INVALID, "Non perfect");
+    pv += weight[mwpm.matching(n)];
+    SmartGraph::Node o = graph.target(mwpm.matching(n));
+    check(mwpm.mate(n) == o, "Invalid matching");
+    check(mwpm.matching(n) == graph.oppositeArc(mwpm.matching(o)),
+          "Invalid matching");
+  }
+
+  int dv = 0;
+  for (SmartGraph::NodeIt n(graph); n != INVALID; ++n) {
+    dv += mwpm.nodeValue(n);
+  }
+
+  for (int i = 0; i < mwpm.blossomNum(); ++i) {
+    check(mwpm.blossomValue(i) >= 0, "Invalid blossom value");
+    check(mwpm.blossomSize(i) % 2 == 1, "Even blossom size");
+    dv += mwpm.blossomValue(i) * ((mwpm.blossomSize(i) - 1) / 2);
+  }
+
+  check(pv * mwpm.dualScale == dv * 2, "Wrong duality");
+
+  return;
+}
+
+
+int main() {
+
+  for (int i = 0; i < lgfn; ++i) {
+    SmartGraph graph;
+    SmartGraph::EdgeMap<int> weight(graph);
+
+    istringstream lgfs(lgf[i]);
+    graphReader(graph, lgfs).
+      edgeMap("weight", weight).run();
+
+    MaxWeightedMatching<SmartGraph> mwm(graph, weight);
+    mwm.run();
+    checkMatching(graph, weight, mwm);
+
+    MaxMatching<SmartGraph> mm(graph);
+    mm.run();
+
+    MaxWeightedPerfectMatching<SmartGraph> mwpm(graph, weight);
+    bool perfect = mwpm.run();
+
+    check(perfect == (mm.size() * 2 == countNodes(graph)),
+          "Perfect matching found");
+
+    if (perfect) {
+      checkPerfectMatching(graph, weight, mwpm);
+    }
+  }
+
+  return 0;
+}
